@startuml
title 4 assignData
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "kitchenJobManager.currentKitchenJob: KitchenJob" as kj
participant "r: KitchenJobReceiver" as rec

Actor -> kjm++: assignData(name?, author?, peopleNumber?, quantity?, tacc?, tacv?, tt?, tuc?, tuv?)

alt currentKitchenJob == null 
    kjm -->> Actor: throw UseCaseLogicException
else
    opt name != null
      kjm -> kj++:setName(name)
      kj -->> kjm--
    end

    opt author != null
      kjm -> kj++:setAuthor(author)
      kj -->> kjm--
    end

    opt peopleNumber != null
      kjm -> kj++:setPeopleNumber(peopleNumber)
      kj -->> kjm--
    end

    opt quantity != null
      kjm -> kj++:setQuantity(quantity)
      kj -->> kjm--
    end

    opt tacc != null
      kjm -> kj++:setTACC(tacc)
      kj -->> kjm--
    end

    opt tacv != null
      kjm -> kj++:setTACV(tacv)
      kj -->> kjm--
    end

    opt tt != null
      kjm -> kj++:setTT(tt)
      kj -->> kjm--
    end

    opt tuc != null
      kjm -> kj++:setTUC(tuc)
      kj -->> kjm--
    end

    opt tuv != null
      kjm -> kj++:setTUV(tuv)
      kj -->> kjm--
    end

    group for each r in receivers
    	kjm -> rec++:notifyAssignedData(currentKitchenJob, simpleStep)
        deactivate rec
    end 
    
    kjm -->> Actor--
    
end
@enduml
